package com.sensu.automall.activity_inquiry

import android.Manifest
import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.net.Uri
import android.os.Bundle
import android.os.Message
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.*
import android.text.method.LinkMovementMethod
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.widget.EditText
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.alibaba.fastjson.JSON
import com.componentservice.UserInfos
import com.jaeger.library.StatusBarUtil
import com.qipeilong.base.commonadapter.rv.CommonAdapter
import com.qipeilong.base.commonadapter.rv.base.FooterViewHolder
import com.qipeilong.base.commonadapter.rv.base.HeaderViewHolder
import com.qipeilong.base.commonadapter.rv.base.ViewHolder
import com.qipeilong.base.commonadapter.rv.wrapper.HeaderAndFooterWrapper
import com.qipeilong.base.permissions.PermissionListener
import com.sensu.automall.BaseActivity
import com.sensu.automall.LesvinAppApplication
import com.sensu.automall.R
import com.sensu.automall.URL
import com.sensu.automall.autotrack.AutoTrackEvent
import com.sensu.automall.autotrack.AutoTrackProperty
import com.sensu.automall.autotrack.AutoTrackUtil
import com.sensu.automall.dialog.LoadingDialogKt
import com.sensu.automall.dialog.QCustomDialog
import com.sensu.automall.fragment.FROM
import com.sensu.automall.fragment.OrderTypeListener
import com.sensu.automall.fragment.PayFragment
import com.sensu.automall.model.*

import com.sensu.automall.recyclerview.TobeQuotePriceItemDecoration
import com.sensu.automall.recyclerview.TobeQuotePriceItemDecoration.VERTICAL_LIST
import com.sensu.automall.utils.*
import com.sensu.automall.widgets.RoundBackgroundColorSpan
import com.sensu.automall.widgets.dialog.TradeTipDialog
import kotlinx.android.synthetic.main.activity_quoteprice_submit.*
import org.json.JSONArray
import org.json.JSONObject
import java.io.Serializable
import java.lang.ref.WeakReference
import java.util.*
import java.util.Map

class QuotePriceSubmitActivity : BaseActivity {

    constructor() {
        activity_LayoutId = R.layout.activity_quoteprice_submit
    }

    val progressUtil: LoadingDialogKt = LoadingDialogKt.newInstance()

    init {
        progressUtil.setD_FgTag("loading").setD_DimAmount(0f).setD_OutCancel(false)
    }

    companion object {
        @JvmStatic
        fun startActivity(activity: Context, quotePriceedDetailModelJ: QuotePriceedDetailModelJ, quoteItems: MutableList<QuoteItemsInfoResponseJ>) {
            var intent = Intent(activity, QuotePriceSubmitActivity::class.java)
            intent.putExtra("quotePriceedDetailModel", quotePriceedDetailModelJ)
            intent.putExtra("quoteItems", quoteItems as Serializable)
            activity.startActivity(intent)
        }

        private var finishListeners: MutableMap<WeakReference<Context>, OnFinishListener> = mutableMapOf()

        @JvmStatic
        fun setFinishlistener(activity: Context, listener: OnFinishListener) {
            var refrence = WeakReference<Context>(activity)
            finishListeners.put(refrence, listener)
        }

        @JvmStatic
        fun removeListener(activity: Context) {
            finishListeners?.remove(WeakReference(activity))
        }
    }

    lateinit var headerAndFooterWrapper: HeaderAndFooterWrapper<String>

    val quotePriceedDetailModel by lazy {
        intent.getSerializableExtra("quotePriceedDetailModel") as QuotePriceedDetailModelJ
    }
    val mQuoteItems by lazy {
        intent.getSerializableExtra("quoteItems") as MutableList<QuoteItemsInfoResponseJ>
    }
    var tv_sum_money: TextView? = null
    val mAmountMap = mutableMapOf<QuoteItemsInfoResponseJ, Int>()
    var sumprice = 0.0;
    var order_uid = mutableListOf<String>()
    var InquiryDetail_URL: String? = null
    var hasSubmited = false

    lateinit var top: View
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        cancelFullProgressView()
        StatusBarUtil.setColor(this, resources.getColor(R.color.white_text_color), 0)
        StatusBarUtil.setLightMode(this)
    }

    @SuppressLint("SetTextI18n")
    override fun initView() {
        super.initView()
        setTitleText("确认订单")

        //头部报价失效倒计时
        top = findViewById(R.id.header_layout)
        val tv_hour = top.findViewById<TextView>(R.id.tv_hour)
        val tv_minute = top.findViewById<TextView>(R.id.tv_minute)
        if (quotePriceedDetailModel.enquiryInfo.quoteTime <= 0) {
            tv_hour.text = "00"
            tv_minute.text = "00"
        } else {
            val date = DateUtil.getDateBySeconds(quotePriceedDetailModel.enquiryInfo.quoteTime)
            tv_hour.text = date[0]
            tv_minute.text = date[1]
        }

        mQuoteItems.forEach {
            mAmountMap.put(it, 1)
        }

        var mAdapter = object : CommonAdapter<QuoteItemsInfoResponseJ>(this, R.layout.item_quoteprice_submit, mQuoteItems) {
            override fun convert(holder: ViewHolder, o: QuoteItemsInfoResponseJ, position: Int) {
                if (position == 1) {
                    holder.getView<TextView>(R.id.tv_title).visibility = View.VISIBLE
                } else {
                    holder.getView<TextView>(R.id.tv_title).visibility = View.GONE
                }
                if (TextUtils.isEmpty(o.remark)) {
                    holder.getView<TextView>(R.id.tv_remark).visibility = View.GONE
                    holder.getView<View>(R.id.remark_space).visibility = View.GONE
                } else {
                    holder.getView<TextView>(R.id.tv_remark).visibility = View.VISIBLE
                    holder.getView<View>(R.id.remark_space).visibility = View.VISIBLE
                    holder.getView<TextView>(R.id.tv_remark).text = o.remark
                }
                holder.getView<TextView>(R.id.tv_oe).setText(o.oeNo)
                holder.getView<TextView>(R.id.tv_money).text = "¥" + o.price
                if (o.isWarranty > 0 && o.kilometre > 0) {
                    holder.getView<TextView>(R.id.tv_quality).text = o.getIsWarranty().toString() + "月" + o.getKilometre() + "公里";
                } else if (o.isWarranty > 0) {
                    holder.getView<TextView>(R.id.tv_quality).text = o.getIsWarranty().toString() + "月";
                } else if (o.kilometre > 0) {
                    holder.getView<TextView>(R.id.tv_quality).text = o.getKilometre().toString() + "公里";
                } else {
                    holder.getView<ImageView>(R.id.iv_quality).setImageResource(R.drawable.item_quoteprice_quality_gray)
                    holder.getView<TextView>(R.id.tv_quality).text = "无"
                }

                val str1 = o.productName + "  "
                var str2 = o.brandName
                if (TextUtils.isEmpty(str2)) {
                    str2 = ""
                }
                val tv_goodsname = holder.getView<View>(R.id.tv_goodsname) as TextView
                tv_goodsname.visibility = View.INVISIBLE
                val spannableString = SpannableString(str1 + str2)
                val spannableString2 = SpannableString(str1 + "\n" + str2)
                val bgColor: Int
                bgColor = if (o.productSourceRequirement == 1) {
                    Color.parseColor("#269b9bf9")
                } else {
                    Color.parseColor("#263C84FB")
                }
                val textColor = Color.parseColor("#FF9B9BF9")
                val span = RoundBackgroundColorSpan(4, bgColor, textColor, 13, 5)
                spannableString.setSpan(span, str1.length, (str1 + str2).length, Spannable.SPAN_INCLUSIVE_INCLUSIVE)
                tv_goodsname.text = spannableString
                tv_goodsname.movementMethod = LinkMovementMethod.getInstance()
                tv_goodsname.post {
                    val lineCount = tv_goodsname.lineCount
                    if (lineCount > 1) {
                        tv_goodsname.text = str1
                    }
                    val lineCount2 = tv_goodsname.lineCount
                    if (lineCount > lineCount2) {
                        spannableString2.setSpan(span, str1.length, (str1 + "\n" + str2).length, Spannable.SPAN_INCLUSIVE_INCLUSIVE)
                        tv_goodsname.text = spannableString2
                    }
                    tv_goodsname.visibility = View.VISIBLE
                }

                if (o.spot == 1) { //现货
                    holder.getView<TextView>(R.id.tv_spot).text = "现货";
                } else { //调货
                    holder.getView<TextView>(R.id.tv_spot).text = "调货" + o.isSpot + "天";
                }

                holder.getView<TextView>(R.id.tv_reduce).setOnClickListener {
                    var amount = mAmountMap.get(o) as Int
//                    var amount = getAmount()
                    if (amount > 1) {
                        amount--
                    } else {
                        amount = 1
                    }
                    holder.getView<EditText>(R.id.et_number).isFocusable = false
                    holder.getView<EditText>(R.id.et_number).isFocusableInTouchMode = false
                    holder.getView<EditText>(R.id.et_number).clearFocus()
                    holder.getView<EditText>(R.id.et_number).setText(amount.toString())
                }
                holder.getView<TextView>(R.id.tv_plus).setOnClickListener {
                    var amount = mAmountMap.get(o) as Int
//                    var amount = getAmount()
                    if (amount >= 9999) {
                        Toast("最多购买9999件")
                        return@setOnClickListener
                    }
                    amount++;
                    holder.getView<EditText>(R.id.et_number).isFocusable = false
                    holder.getView<EditText>(R.id.et_number).isFocusableInTouchMode = false
                    holder.getView<EditText>(R.id.et_number).clearFocus()
                    holder.getView<EditText>(R.id.et_number).setText(amount.toString())
                }

                holder.getView<EditText>(R.id.et_number).setOnTouchListener { v, event ->
                    if (event.action == MotionEvent.ACTION_UP) {
                        holder.getView<EditText>(R.id.et_number).requestFocus()
                        holder.getView<EditText>(R.id.et_number).isFocusable = true
                        holder.getView<EditText>(R.id.et_number).isFocusableInTouchMode = true
                        holder.getView<EditText>(R.id.et_number).setSelection(holder.getView<EditText>(R.id.et_number).text?.length!!)
                    }
                    false
                }
                holder.getView<EditText>(R.id.et_number).addTextChangedListener(object : TextWatcher {
                    override fun afterTextChanged(s: Editable?) {
                        var amount = mAmountMap.get(o) as Int
//                        var amount = getAmount()
                        var diff = 0
                        if (s == null || s.isEmpty()) {
                            mAmountMap.put(o, 0)
                            diff = -amount
                            sumprice += diff * o.price.toDouble()
                            if (sumprice <= 0) {
                                sumprice = 0.0
                            }
                            tv_sum_money?.text = "¥" + String.format("%.2f", sumprice)
                            tv_real_price.text = "¥" + String.format("%.2f", (sumprice + quotePriceedDetailModel?.quoteInfo.deliverPrice.toDouble()))
//                            tv_products_count.text = "共" + (diff + amount) + "件商品"
                            tv_products_count.text = "共" + getAmount() + "件商品"
                        } else {
                            if (s.toString().equals("0")) {
                                holder.getView<EditText>(R.id.et_number).setText("1")
                            } else {
                                diff = s.toString().toInt() - amount
                                mAmountMap.put(o, s.toString().toInt())
                                sumprice += diff * o.price.toDouble()
                                tv_sum_money?.text = "¥" + String.format("%.2f", sumprice) + ""
                                tv_real_price.text = "¥" + String.format("%.2f", (sumprice + quotePriceedDetailModel?.quoteInfo.deliverPrice.toDouble()))
//                                tv_products_count.text = "共" + (diff + amount) + "件商品"
                                tv_products_count.text = "共" + getAmount() + "件商品"
                            }
                        }
                    }

                    override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
                    }

                    override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {

                    }
                })
            }
        }
        headerAndFooterWrapper = HeaderAndFooterWrapper<String>(mAdapter)
        recyclerview.let {
            it.layoutManager = LinearLayoutManager(this)
            it.addItemDecoration(TobeQuotePriceItemDecoration(this, VERTICAL_LIST, MassageUtils.dip2px(10f)))
        }
        var headView = LayoutInflater.from(this).inflate(R.layout.head_quote_price_submit, recyclerview, false)
        var footerView = LayoutInflater.from(this).inflate(R.layout.footer_quotepricesubmit, recyclerview, false)

        headerAndFooterWrapper.let {
            it.addHeaderView(headView, object : HeaderAndFooterWrapper.HeadViewListener {
                override fun head(holder: RecyclerView.ViewHolder?) {
                    if (holder is HeaderViewHolder) {
                        quotePriceedDetailModel.apply {
                            holder.getView<TextView>(R.id.tv_address).text = deliveryInfo?.address
                            holder.getView<TextView>(R.id.tv_cartype).text = enquiryInfo?.carName
                            holder.getView<TextView>(R.id.tv_contact_mobile).text = deliveryInfo?.phone
                            holder.getView<TextView>(R.id.tv_inquiryno).text = enquiryInfo?.inquiryNo
                            holder.getView<TextView>(R.id.tv_ordertime).text = enquiryInfo?.enquiryTime

                            if (TextUtils.isEmpty(enquiryInfo?.productSourceRequirement)) {
                                holder.getView<TextView>(R.id.tv_quality).text = "暂无"
                            } else {
                                holder.getView<TextView>(R.id.tv_quality).text = enquiryInfo?.productSourceRequirement
                            }

                            holder.getView<TextView>(R.id.tv_receiver).text = deliveryInfo?.contacts
                            holder.getView<TextView>(R.id.tv_shapphone).text = contactPhone

                            holder.getView<TextView>(R.id.tv_shapphone).setOnClickListener(View.OnClickListener { v ->
                                run {
                                    showCallPhoneDialog(contactPhone)
                                }
                            })
//                            holder.getView<TextView>(R.id.tv_shapphone).setOnClickListener({v ->call(this@QuotePriceSubmitActivity,contactPhone)})

                            holder.getView<ImageView>(R.id.iv_shapphone).setOnClickListener(View.OnClickListener { v ->
                                run {
                                    showCallPhoneDialog(contactPhone)
                                }
                            })

                            holder.getView<TextView>(R.id.tv_time).text = quoteInfo?.quoteTime
                            if (TextUtils.isEmpty(enquiryInfo?.vin)) {
                                holder.getView<LinearLayout>(R.id.ll_vin).visibility = View.GONE
                            } else {
                                holder.getView<LinearLayout>(R.id.ll_vin).visibility = View.VISIBLE
                                holder.getView<TextView>(R.id.tv_vin).text = enquiryInfo?.vin
                            }
                            holder.getView<TextView>(R.id.tv_deliver_price).text = String.format("%.2f", quoteInfo?.deliverPrice?.toDouble()) + "元"
                        }
                    }
                }

            })
            it.addFootView(footerView, object : HeaderAndFooterWrapper.FooterViewListener {
                override fun footer(holder: RecyclerView.ViewHolder?) {
                    if (holder is FooterViewHolder) {
                        holder.getView<TextView>(R.id.tv_delevery).setText("¥" + String.format("%.2f", quotePriceedDetailModel.quoteInfo?.deliverPrice?.toDouble()))
                        tv_sum_money = holder.getView<TextView>(R.id.tv_sum_money)
                        holder.getView<TextView>(R.id.tv_sum_money).setText("¥" + String.format("%.2f", sumprice))
                    }
                }

            })
        }
        mQuoteItems.forEach {
            sumprice += it.price.toDouble()
        }
        recyclerview.adapter = headerAndFooterWrapper
        tv_real_price.text = "¥" + String.format("%.2f", (sumprice + quotePriceedDetailModel.quoteInfo.deliverPrice.toDouble()))
//        tv_products_count.text = "共" + (mQuoteItems.size) + "件商品"
        tv_products_count.text = "共" + getAmount() + "件商品"

        tv_submit.setOnClickListener(object : SingleOnClickListener() {
            override fun onSingleClick(view: View?) {
                if (!hasSubmited) {
                    SaveInquiryOrder()
                } else {
                    var orderNos = ""
                    order_uid?.forEach {
                        orderNos += it + ","
                    }
                    PayFragment.injectIfNeededIn(this@QuotePriceSubmitActivity, OrderTypeListener.INQUIRY, orderNos, object : OrderTypeListener {
                        override fun onFail(errorMsg: String) {
                            showTopLine(errorMsg)
                        }

                        override fun onSuccess() {
                            finish()
                            onFinish()
                        }
                    }, FROM.CUSTOM, InquiryDetail_URL!!)
                }
            }
        })
        getTraderPauseInfo()
    }

    fun showCallPhoneDialog(number: String) {
        if (TextUtils.isEmpty(number))
            return
        QCustomDialog.Builder(this)
                .setTitle("是否拨打")
                .setContent(number)
                .setNegative("取消", object : QCustomDialog.Builder.OnClickQDialogListener {
                    override fun onClick(dialog: QCustomDialog) {
                        dialog.dismiss()
                    }

                })
                .setPositive("确定", object : QCustomDialog.Builder.OnClickQDialogListener {
                    override fun onClick(dialog: QCustomDialog) {
                        dialog.dismiss()
                        SystemUtils.callPhone(this@QuotePriceSubmitActivity, number)
                    }
                })
                .create()
                .setD_FgTag("cancelOrder")
                .show(supportFragmentManager)
    }

    fun SaveInquiryOrder() {
        progressUtil?.show(supportFragmentManager)
        var requestParams = JSONObject()
        requestParams.put("inquiryUid", quotePriceedDetailModel.inquiryUid)
        requestParams.put("quoteUid", quotePriceedDetailModel.quoteInfo?.quoteUId)
        requestParams.put("traderId", quotePriceedDetailModel.quoteInfo?.traderId)
        var inquiryOrderItems = JSONArray()
        mAmountMap.forEach {
            if (it.value == 0) {
                showTopLine("请填写商品的数量")
                return
            }
            var inquiryOrderItem = JSONObject()
            inquiryOrderItem.put("quoteItemsUid", it.key?.quoteItemsUId)
            inquiryOrderItem.put("amount", it.value)

            inquiryOrderItems.put(inquiryOrderItem)
        }
        requestParams.put("paymentMethod", 1)
        requestParams.put("orderUserName", applicationUserInfo?.UserName)
        requestParams.put("orderUserID", applicationUserInfo?.UID)
        requestParams.put("quoteItems", inquiryOrderItems)
        requestParams.put("deliveryFee", quotePriceedDetailModel.quoteInfo?.deliverPrice)

        client.postRequestJ("SaveInquiryOrder", URL.HTTP_SaveInquiryOrderJ, requestParams, activityKey)
    }

    fun getTraderPauseInfo(){
        var requestParams =JSONObject()
        requestParams.put("TraderId",quotePriceedDetailModel.quoteInfo?.traderId)
        client.postRequestJ("JudgeTraderIsPause", URL.HTTP_JudgeTraderIsPauseJ, requestParams, activityKey)
    }

    fun onFinish() {
        finishListeners?.forEach {
            if (it.key.get() != null) {
                it.value.onFinish()
            }
        }
    }

    override fun notifyDataChanged(jsonObject: JSONObject) {
        super.notifyDataChanged(jsonObject)
        try {
            var body = jsonObject.optJSONObject("body")
            var method = jsonObject.optString("method")
            if ("SaveInquiryOrder".equals(method)) {
                hasSubmited = true
                order_uid = JSON.parseArray(body.optJSONObject("data").optJSONArray("orderList").toString(), String::class.java)
                InquiryDetail_URL = body.optJSONObject("data").optString("inquiryUrl")
                var orderNos = ""
                order_uid?.forEach {
                    orderNos += it + ","
                }
                PayFragment.injectIfNeededIn(this, OrderTypeListener.INQUIRY, orderNos, object : OrderTypeListener {
                    override fun onFail(errorMsg: String) {
                        showTopLine(errorMsg)
                        progressUtil?.dismiss()
                    }

                    override fun onSuccess() {
                        onFinish()
                        progressUtil?.dismiss()
                        finish()
                    }
                }, FROM.CUSTOM, InquiryDetail_URL!!)
                try {
                    val properties = JSONObject()
                    properties.put(AutoTrackProperty.click_action, "询价/确认订单事件")
                    AutoTrackUtil.track_click(AutoTrackEvent.QPL_inquirySubmitOrder, properties)
                } catch (e: Exception) {
                    e.printStackTrace()
                }

            } else if ("JudgeTraderIsPause" == method) {
                if (body.optBoolean("success")) {
                    val data = body.optJSONObject("data")
                    if (data != null) {
                        val traderPauseInfo = JsonParser.parseObject(data.toString(), TraderPauseInfoJ::class.java)
                        if (traderPauseInfo.isPause) {
                            updateSubmitBtn(traderPauseInfo)
                        }
                    }
                }
            }

        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    public interface OnFinishListener {
        fun onFinish()
    }

    private fun updateSubmitBtn(traderPauseInfo: TraderPauseInfoJ) {
        tv_submit.setText("休业中")
        tv_submit.setBackgroundColor(resources.getColor(R.color.gray_vin))
        tv_submit.setOnClickListener(object : SingleOnClickListener() {
            override fun onSingleClick(view: View) {
                toastShutTip(traderPauseInfo)
            }
        })
    }

    private var tradeTipDialog: TradeTipDialog? = null
    /**
     * 休业提示
     */
    fun toastShutTip(traderPauseInfo: TraderPauseInfoJ) {
        try {
            val title = traderPauseInfo.messageTitle
            val content = traderPauseInfo.messageContent
            tradeTipDialog = TradeTipDialog(this, title + "", content + "")
            tradeTipDialog!!.show()
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun getAmount(): Int {
        var aomunt = 0
        mAmountMap.forEach { (key, value) ->
            try {
                aomunt = aomunt + value
            } catch (e: java.lang.Exception) {
                e.printStackTrace()
            }
        }
        return aomunt
    }

    override fun handleErrorMessage(msg: Message?): Int {
        try {
            var json = msg?.obj as JSONObject;
            var jsonObject = JSONObject(json.optString("body"));
            var method = jsonObject.optString("method");
            if (method.equals("SaveInquiryOrder")) {
                progressUtil?.dismiss()
                if (!jsonObject.optBoolean("success") && !TextUtils.isEmpty(jsonObject.optString("message"))) {
                    showTopLine(jsonObject.optString("message"))
                }
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return super.handleErrorMessage(msg)
    }

    override fun onDestroy() {
        if (tradeTipDialog != null) {
            tradeTipDialog!!.close()
        }
        super.onDestroy()
        finishListeners?.clear()
    }
}