package com.sensu.automall.activity_mycenter

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.View
import com.qipeilong.base.commonadapter.rv.MultiItemTypeAdapter
import com.qipeilong.base.emptyview.EmptyViewLayoutManager
import com.sensu.automall.BaseActivity
import com.sensu.automall.R
import com.sensu.automall.adapter.CouponsAdapter
import com.sensu.automall.manager.SetStatusStrategry
import com.sensu.automall.manager.StatusStrategry
import com.sensu.automall.model.CouponInfo
import kotlinx.android.synthetic.main.activity_writeordercoupons.*
import java.io.Serializable

class WriteOrderCouponsActivity:BaseActivity{

    constructor(){
        activity_LayoutId = R.layout.activity_writeordercoupons
    }

    companion object {
        @JvmStatic
        fun startActivityforResult(context:Activity,couponsList:List<CouponInfo>,selected:CouponInfo?,un_used_selected:Boolean,requestCode:Int){
            var intent =Intent(context,WriteOrderCouponsActivity::class.java)
            intent.putExtra("couponsList",couponsList as Serializable)
            intent.putExtra("selected",selected)
            intent.putExtra("un_used_selected",un_used_selected)
            context.startActivityForResult(intent,requestCode)
        }
    }


    val couponsList = arrayListOf<CouponInfo>()
    var mSelectedCouponInfo:CouponInfo?=null
    lateinit var  couponsAdapter:CouponsAdapter
    val listMap = hashMapOf<Int,Boolean>()
    val mEmptyViewManager :EmptyViewLayoutManager
    var un_used_selected = false
    var isUseCoupon =false
    init {
        mEmptyViewManager= EmptyViewLayoutManager.newInstance().setLayoutRes(R.layout.no_coupon_data)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        cancelFullProgressView()
        SetStatusStrategry(StatusStrategry.WHITE,this)
    }

    override fun initView() {
        super.initView()
        setTitleText("优惠券")

        intent.extras?.let {
            if(it.containsKey("couponsList")){
                couponsList.addAll(it.getSerializable("couponsList") as List<CouponInfo>)
            }
            if(it.containsKey("selected")){
                if(it.getSerializable("selected")!=null){
                    mSelectedCouponInfo = it.getSerializable("selected") as CouponInfo
                }
            }
            if(it.containsKey("un_used_selected")){
                un_used_selected = it.getBoolean("un_used_selected")
            }
        }

        if(un_used_selected){
            isUseCoupon=true
            iv_used.setImageResource(R.drawable.coupons_used)
        }

        recyclerView_coupons.layoutManager=LinearLayoutManager(this)

        mSelectedCouponInfo?.let {
            var cou = it
            run loop@ {
                couponsList?.forEachIndexed { index, couponInfo ->
                    if(!TextUtils.isEmpty(cou.couponId)){
                        if(cou.couponId.equals(couponInfo.couponId)){
                            listMap.put(index,true)
                            return@loop
                        }
                    }
                }
            }
        }

        couponsAdapter=CouponsAdapter(this,R.layout.mycoupons_item_lay,couponsList,listMap)
        couponsAdapter.setCouponFrom(CouponsAdapter.CouponFrom.WRITE_ORDER)

        couponsAdapter.setOnItemClickListener(object :MultiItemTypeAdapter.OnItemClickListener{
            override fun onItemLongClick(view: View?, holder: RecyclerView.ViewHolder?, position: Int): Boolean {
                return false
            }

            override fun onItemClick(view: View?, holder: RecyclerView.ViewHolder?, position: Int) {
                listMap.clear()
                listMap.put(position,true)
                couponsAdapter.notifyDataSetChanged()

                var intent = Intent()
                intent.putExtra("coupon",couponsList.get(position))
                setResult(RESULT_OK,intent)
                finish()
            }


        })
        recyclerView_coupons.adapter = couponsAdapter

        rl_coupons_use.setOnClickListener {
            if (isUseCoupon){
                isUseCoupon=false
                iv_used.setImageResource(R.drawable.coupons_unused)
            }else{
                isUseCoupon=true
                iv_used.setImageResource(R.drawable.coupons_used)
            }
            listMap.clear()
            couponsAdapter.notifyDataSetChanged()

            var intent = Intent()
            setResult(RESULT_OK,intent)
            finish()
        }
    }
}