package com.sensu.automall.adapter

import android.content.Context
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.ImageView
import android.widget.TextView
import com.componentservice.UserInfos
import com.sensu.automall.LesvinAppApplication
import com.sensu.automall.R
import com.sensu.automall.model.Store

class ChooseStoreAdapter(private var context : Context, private var stores : List<Store>, var curClickPos : Int) : BaseAdapter(){
    override fun getView(position: Int, convertView: View?, parent: ViewGroup?): View {

        val users : UserInfos? = LesvinAppApplication.getUsers()
        val holder : ViewHolder
        var view : View? = convertView
       if (convertView == null){
           holder = ViewHolder()
           view = LayoutInflater.from(context).inflate(R.layout.item_choose_store, null)
           holder.dmCode = view.findViewById(R.id.dmcode_tv)
           holder.name = view.findViewById(R.id.name_tv)
           holder.chooseStatusIcon = view.findViewById(R.id.choose_status_im)
           view.tag = holder
       }else{
           holder = convertView.tag as ViewHolder
       }
        if ((!TextUtils.isEmpty(stores[position].Uid) && stores[position].Uid.equals(users?.UID))
            || curClickPos == position){
            holder.chooseStatusIcon.visibility = View.VISIBLE
        }else{
            holder.chooseStatusIcon.visibility = View.GONE
        }
        holder.dmCode.text = stores[position].UserName
        holder.name.text = stores[position].ShopName
        return view!!
    }

    public fun showChooseStatusIcon(position: Int){
        curClickPos = position
        notifyDataSetInvalidated()
    }

    override fun getItem(position: Int): Any {
       return stores[position]
    }

    override fun getItemId(position: Int): Long {
      return 0
    }

    override fun getCount(): Int {
        return stores.size
    }

    class ViewHolder {
         lateinit var dmCode : TextView
         lateinit var name : TextView
        lateinit var chooseStatusIcon :ImageView
    }
}