package com.sensu.automall.adapter

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.qipeilong.base.commonadapter.rv.CommonAdapter
import com.qipeilong.base.commonadapter.rv.base.ViewHolder
import com.sensu.automall.R
import com.sensu.automall.activity_mycenter.WriteOrderCouponsActivity
import com.sensu.automall.model.CouponInfo
import com.sensu.automall.utils.HtmlStringUtil

open class CouponsAdapter(val context:Context,val layoutId:Int,val datas:ArrayList<CouponInfo>,val listMap:HashMap<Int,Boolean>): CommonAdapter<CouponInfo>(context,layoutId,datas){


    var selected =false
    override fun convert(holder: ViewHolder?, data: CouponInfo?, position: Int) {
        if ( TextUtils.isEmpty(data?.validPeriodType) || "1".equals(data?.validPeriodType)) {
            holder?.getView<TextView>(R.id.tv_data)?.text=data?.startDate?.replace("-",".") + "-" + data?.endDate?.replace("-",".")
        } else {
            holder?.getView<TextView>(R.id.tv_data)?.text="领取后" + data?.validPeriod + "天内有效"
        }
        holder?.getView<TextView>(R.id.tv_ConditionString)?.setText(data?.conditionString)
        if (!listMap.containsKey(position)) {
            if ( !"0".equals(data?.availableAmount)) {
                if (!TextUtils.isEmpty(data?.getReceivedNum())&& !TextUtils.isEmpty(data?.availableAmount)
                        && Integer.parseInt(data?.getReceivedNum()) >= Integer
                                .parseInt(data?.getAvailableAmount())) {
                    if(context is WriteOrderCouponsActivity) {
                        selected = true
                    }else{
                        holder?.getView<ImageView>(R.id.iv_coupon_selected)?.visibility=View.VISIBLE
                    }
                } else {
                    if(context is WriteOrderCouponsActivity) {
                        selected = false
                    }else{
                        holder?.getView<ImageView>(R.id.iv_coupon_selected)?.visibility=View.GONE
                    }
                }
            } else {
                if(context is WriteOrderCouponsActivity){
                    selected =false
                }else{
                    holder?.getView<ImageView>(R.id.iv_coupon_selected)?.visibility=View.GONE
                }
            }
        } else {
            if(context is WriteOrderCouponsActivity){
                selected =true
            }else{
                holder?.getView<ImageView>(R.id.iv_coupon_selected)?.visibility=View.VISIBLE
            }
        }

        holder?.getView<TextView>(R.id.tv_couponName)?.text=data?.couponName
        holder?.getView<TextView>(R.id.tv_CondtionTypeString)?.text=data?.conditionTypeString
        if (data?.couponType == 4 || data?.couponType == 5) {
            holder?.getView<View>(R.id.tv_symbol)?.visibility = View.GONE
        } else {
            holder?.getView<TextView>(R.id.tv_symbol)?.visibility=View.VISIBLE
        }

        if(TextUtils.isEmpty(data?.sourceCouponValue)){
            holder?.getView<TextView>(R.id.tv_CouponValue)?.text = HtmlStringUtil.getCouponValue(data?.couponValue, 20, 14)
        }else{
            holder?.getView<TextView>(R.id.tv_CouponValue)?.text = HtmlStringUtil.getCouponValue(data?.sourceCouponValue, 20, 14)
        }

        if (data?.crashType == 1 || data?.crashType == 2) {
            if(selected){
                holder?.getView<ImageView>(R.id.iv_coupon)?.setBackgroundResource(R.drawable.on_money_cash_selected)
            }else{
                holder?.getView<ImageView>(R.id.iv_coupon)?.setBackgroundResource(R.drawable.on_money_cash)
            }
        }else{
            if(selected){
                holder?.getView<ImageView>(R.id.iv_coupon)?.setBackgroundResource(R.drawable.on_cash_selected)
            }else{
                holder?.getView<ImageView>(R.id.iv_coupon)?.setBackgroundResource(R.drawable.on_cash)
            }
        }
    }

    fun setCouponFrom(couponFrom: CouponFrom){
        mCouponFrom =couponFrom
    }

    var  mCouponFrom=CouponFrom.PRODUCT_DETAIL

    enum class CouponFrom{
        PRODUCT_DETAIL,
        SHOPPING_CAR,
        WRITE_ORDER
    }

}