package com.sensu.automall.db

import android.content.Context
import android.database.sqlite.SQLiteDatabase
import com.sensu.automall.model.SearchSortModel
import com.sensu.automall.utils.GsonParseUtil
import com.sensu.automall.utils.MassageUtils
import com.sensu.automall.utils.SharedPreferenceUtil
import org.litepal.LitePal

class SearchSortDBUtils{


    val db :SQLiteDatabase

    private constructor(){
        db = LitePal.getDatabase()
    }

    companion object {
        val instance :SearchSortDBUtils by lazy(mode = LazyThreadSafetyMode.SYNCHRONIZED) {
            SearchSortDBUtils()
        }
    }


    fun saveAll(searchSorts : List<SearchSortModel>){
        if(searchSorts?.size>0){
            LitePal.saveAll(searchSorts)
        }
    }

    fun deleteAll(){
        LitePal.deleteAll(SearchSortModel::class.java)
    }

    fun findAll():List<SearchSortModel>{
        return LitePal.findAll(SearchSortModel::class.java)
    }

    fun findAllFromSP(context: Context) :List<SearchSortModel>{
        var searchsorts:List<SearchSortModel> = GsonParseUtil.parseArray(MassageUtils.getFromSP(context,
                                SharedPreferenceUtil.SEARCHSORT_TITLE,SharedPreferenceUtil.SEARCHSORT_KEY),SearchSortModel::class.java)
        return searchsorts
    }

}