package com.sensu.automall.db.room;

import android.arch.persistence.room.Database;
import android.arch.persistence.room.Room
import android.arch.persistence.room.RoomDatabase;
import android.content.Context

import com.sensu.automall.db.room.dao.LaunchAdvertiseDao;
import com.sensu.automall.model.LaunchAdvertiseModel;

@Database(entities = [LaunchAdvertiseModel::class],version = 1)
abstract class AppDatabase : RoomDatabase() {

    abstract fun launchAdvertiseDao():LaunchAdvertiseDao

    companion object {
        @Volatile private var instance:AppDatabase?=null

        fun getInstance(context: Context):AppDatabase{
            return instance?: synchronized(this){
                instance?: buildDatabase(context)
            }
        }

        private fun buildDatabase(context: Context):AppDatabase{
            return Room.databaseBuilder(context,AppDatabase::class.java,"qpl_room")
                    .build()
        }
    }


}
