package com.sensu.automall.db.room.dao

import android.arch.persistence.room.*
import com.sensu.automall.model.LaunchAdvertiseModel
import io.reactivex.Flowable

@Dao
interface LaunchAdvertiseDao{

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    fun insertLaunchAdvertise(launchAdvertiseModel: LaunchAdvertiseModel)

    @Delete
    fun deleteLaunchAdvertise(launchAdvertiseModel: List<LaunchAdvertiseModel>)

    @Update(onConflict = OnConflictStrategy.REPLACE)
    fun updateLaunchAdvertise(launchAdvertiseModel: LaunchAdvertiseModel)

    @Query("select * from LaunchAdvertise")
    fun getLaunchAdvertise():Flowable<List<LaunchAdvertiseModel>>

    @Query("delete from LaunchAdvertise")
    fun deleteAll()
}