package com.sensu.automall.db.room.repository

import com.sensu.automall.db.room.dao.LaunchAdvertiseDao
import com.sensu.automall.model.LaunchAdvertiseModel
import io.reactivex.Flowable

class LaunchAdvertiseRepository private constructor(private val launchAdvertiseDao: LaunchAdvertiseDao){

    fun insertLaunchAdvertise(launchAdvertiseModel: LaunchAdvertiseModel) = launchAdvertiseDao.insertLaunchAdvertise(launchAdvertiseModel)

    fun updateLaunchAdvertise(launchAdvertiseModel: LaunchAdvertiseModel) = launchAdvertiseDao.updateLaunchAdvertise(launchAdvertiseModel)

    fun getLaunchAdvertise(): Flowable<List<LaunchAdvertiseModel>> = launchAdvertiseDao.getLaunchAdvertise()

    fun deleteLaunchAdvertise(launchAdvertiseModel: List<LaunchAdvertiseModel>)=launchAdvertiseDao.deleteLaunchAdvertise(launchAdvertiseModel)

    fun deleteAll() = launchAdvertiseDao.deleteAll()

    companion object {
        @Volatile private var instance:LaunchAdvertiseRepository?=null

        fun getInstance(launchAdvertiseDao: LaunchAdvertiseDao)=
                instance?: synchronized(this){
                    instance?:LaunchAdvertiseRepository(launchAdvertiseDao).also { instance = it }
                }
    }
}