package com.sensu.automall.dialog

import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.View
import android.widget.TextView
import com.qipeilong.base.commonadapter.rv.CommonAdapter
import com.qipeilong.base.commonadapter.rv.base.ViewHolder
import com.sensu.automall.R
import com.sensu.automall.model.DeliveryTemplate
import com.sensu.automall.model.DeliveryWay
import kotlinx.android.synthetic.main.dialog_writeorder_delivery.*

class DeliveryDetailDialog :BaseDialog(){
    override fun layoutRes(): Int {
       return R.layout.dialog_writeorder_delivery
    }

    var deliveryTemplates:MutableList<String> = mutableListOf()
    var adapter:CommonAdapter<String>?=null
    var deliveryWay:DeliveryWay?=null
    override fun initView(view: View) {
        super.initView(view)

        recyclerview.layoutManager=LinearLayoutManager(context)
        adapter=object :CommonAdapter<String>(context, R.layout.item_deliverydetaildialog,deliveryTemplates){
            override fun convert(holder: ViewHolder?, t: String?, position: Int) {
                holder?.getView<TextView>(R.id.tv_deliverydetail)?.text=t
                //holder?.getView<TextView>(R.id.tv_notes)?.text=t?.Notes
            }
        }
        recyclerview.adapter=adapter
        tv_deliveryname.text=deliveryWay?.deliveryName
        when{
            deliveryWay?.amount==0 ->        tv_amount.text="包邮"
            else                   ->        tv_amount.text="¥"+deliveryWay?.amount.toString()
        }
        tv_close.setOnClickListener { dismiss() }
    }

    fun setData(delivery:DeliveryWay,list:MutableList<DeliveryTemplate>){
        deliveryWay=delivery
        deliveryTemplates.clear()
        list?.forEach {
            var str = "*"+it.postTips
            deliveryTemplates.add(str)
        }
        deliveryTemplates.add("运费说明:")
        var hasNotes = false
        list?.forEach {
            var str = it.notes
            if(!TextUtils.isEmpty(str)){
                hasNotes=true
                deliveryTemplates.add(str)
            }
        }
        if(!hasNotes){
            deliveryTemplates.add("暂无说明")
        }
        adapter?.notifyDataSetChanged()

    }
}