package com.sensu.automall.dialog

import android.app.Activity
import android.content.Context
import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentActivity
import android.view.LayoutInflater
import android.view.View
import android.widget.TextView
import com.sensu.automall.R
import com.sensu.automall.utils.MassageUtils
import com.sensu.automall.utils.ScreenUtil

class MergePayDialog : BaseDialog(){

    protected override fun layoutRes(): Int {
        return -1
    }

    var tv_title :TextView?=null
    var tv_content:TextView?=null
    var tv_negative:TextView?=null
    var tv_positive:TextView?=null
    var tv_price :TextView?=null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setD_OutCancel(false)
        //setD_Height(MassageUtils.dip2px(200f))
        setD_Width((ScreenUtil.getScreenWidth(context) * 0.8).toInt())
    }

    class Builder{
        var mTitle:String?=null
        var mContent:String?=null
        var mPrice:String?=null
        var mNegativeButtonContent:String?=null
        var mNegativeButtonListener:OnClickQDialogListener?=null
        var mPositiveButtonContent:String?=null
        var mPositiveButtonListener:OnClickQDialogListener?=null

        var mView:View?=null

        constructor(context: Context){
            mView = LayoutInflater.from(context).inflate(R.layout.dialog_custom_mergepay,null)
        }

        fun setTitle(title:String):Builder{
            mTitle=title
            return this
        }

        fun setContent(content:String):Builder{
            mContent=content
            return this
        }

        fun setPrice(price:String):Builder{
            mPrice=price
            return this
        }

        fun setNegative(name:String,listener:OnClickQDialogListener):Builder{
            mNegativeButtonContent=name
            mNegativeButtonListener=listener
            return this
        }

        fun setPositive(name: String,listener:OnClickQDialogListener):Builder{
            mPositiveButtonContent=name
            mPositiveButtonListener=listener
            return this
        }

        fun create():MergePayDialog{

            var customDialog=MergePayDialog()
            customDialog.setD_LayoutView(mView!!)
            customDialog.tv_title =mView?.findViewById(R.id.tv_title)
            customDialog.tv_content =mView?.findViewById(R.id.tv_content)
            customDialog.tv_price=mView?.findViewById(R.id.tv_price)
            customDialog.tv_negative =mView?.findViewById(R.id.tv_negative)
            customDialog.tv_positive =mView?.findViewById(R.id.tv_positive)

            customDialog.tv_title?.text=this.mTitle
            customDialog.tv_content?.text=this.mContent
            customDialog.tv_price?.text=this.mPrice
            customDialog.tv_negative?.text=this.mNegativeButtonContent
            customDialog.tv_negative?.setOnClickListener {
                mNegativeButtonListener?.onClick(customDialog)
            }
            customDialog.tv_positive?.text=this.mPositiveButtonContent
            customDialog.tv_positive?.setOnClickListener{
                mPositiveButtonListener?.onClick(customDialog)
            }

            return customDialog
        }

        interface OnClickQDialogListener{
            fun onClick(dialog: MergePayDialog)
        }
    }
}