package com.sensu.automall.dialog

import android.app.Activity
import android.content.Context
import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentActivity
import android.view.LayoutInflater
import android.view.View
import android.widget.TextView
import com.sensu.automall.R

class QCustomDialog : BaseDialog(){

    protected override fun layoutRes(): Int {
        return -1
    }

    var tv_title :TextView?=null
    var tv_content:TextView?=null
    var tv_negative:TextView?=null
    var tv_positive:TextView?=null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setD_OutCancel(false)
    }

    class Builder{
        var mTitle:String?=null
        var mContent:String?=null
        var mNegativeButtonContent:String?=null
        var mNegativeButtonListener:OnClickQDialogListener?=null
        var mPositiveButtonContent:String?=null
        var mPositiveButtonListener:OnClickQDialogListener?=null

        var mView:View?=null

        constructor(context: Context){
            mView = LayoutInflater.from(context).inflate(R.layout.dialog_custom,null)
        }

        fun setTitle(title:String):Builder{
            mTitle=title
            return this
        }

        fun setContent(content:String):Builder{
            mContent=content
            return this
        }

        fun setNegative(name:String,listener:OnClickQDialogListener):Builder{
            mNegativeButtonContent=name
            mNegativeButtonListener=listener
            return this
        }

        fun setPositive(name: String,listener:OnClickQDialogListener):Builder{
            mPositiveButtonContent=name
            mPositiveButtonListener=listener
            return this
        }

        fun create():QCustomDialog{

            var customDialog=QCustomDialog()
            customDialog.setD_LayoutView(mView!!)
            customDialog.tv_title =mView?.findViewById(R.id.tv_title)
            customDialog.tv_content =mView?.findViewById(R.id.tv_content)
            customDialog.tv_negative =mView?.findViewById(R.id.tv_negative)
            customDialog.tv_positive =mView?.findViewById(R.id.tv_positive)

            customDialog.tv_title?.text=this.mTitle
            customDialog.tv_content?.text=this.mContent
            customDialog.tv_negative?.text=this.mNegativeButtonContent
            customDialog.tv_negative?.setOnClickListener {
                mNegativeButtonListener?.onClick(customDialog)
            }
            customDialog.tv_positive?.text=this.mPositiveButtonContent
            customDialog.tv_positive?.setOnClickListener{
                mPositiveButtonListener?.onClick(customDialog)
            }

            return customDialog
        }

        interface OnClickQDialogListener{
            fun onClick(dialog: QCustomDialog)
        }

    }
}