package com.sensu.automall.dialog

import android.app.Activity
import android.content.Context
import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentActivity
import android.view.LayoutInflater
import android.view.View
import android.widget.TextView
import com.sensu.automall.R

class SwitchEnvDialog : BaseDialog(){

    protected override fun layoutRes(): Int {
        return -1
    }

    var tv_product :TextView?=null
    var tv_test:TextView?=null
    var tv_tuhutest:TextView?=null
    var tv_ut:TextView?=null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setD_OutCancel(false)
    }

    class Builder{
        var mTestButtonListener:OnClickQDialogListener?=null
        var mProductButtonListener:OnClickQDialogListener?=null
        var mTuhuTestButtonListener:OnClickQDialogListener?=null
        var mUTButtonListener:OnClickQDialogListener?=null

        var mView:View?=null

        constructor(context: Context){
            mView = LayoutInflater.from(context).inflate(R.layout.dialog_switchenv,null)
        }

        fun setProduct(listener:OnClickQDialogListener):Builder{
            mProductButtonListener=listener
            return this
        }

        fun setTest(listener:OnClickQDialogListener):Builder{
            mTestButtonListener=listener
            return this
        }

        fun setTuhuTest(listener:OnClickQDialogListener):Builder{
            mTuhuTestButtonListener=listener
            return this
        }
        fun setUT(listener:OnClickQDialogListener):Builder{
            mUTButtonListener=listener
            return this
        }

        fun create():SwitchEnvDialog{

            var customDialog=SwitchEnvDialog()
            customDialog.setD_LayoutView(mView!!)
            customDialog.tv_product =mView?.findViewById(R.id.tv_product)
            customDialog.tv_test =mView?.findViewById(R.id.tv_test)
            customDialog.tv_tuhutest = mView?.findViewById(R.id.tv_tuhutest)
            customDialog.tv_ut = mView?.findViewById(R.id.tv_ut)

            customDialog.tv_product?.setOnClickListener {
                mProductButtonListener?.onClick(customDialog)
            }
            customDialog.tv_test?.setOnClickListener{
                mTestButtonListener?.onClick(customDialog)
            }
            customDialog.tv_tuhutest?.setOnClickListener{
                mTuhuTestButtonListener?.onClick(customDialog)
            }
            customDialog.tv_ut?.setOnClickListener{
                mUTButtonListener?.onClick(customDialog)
            }
            return customDialog
        }

        interface OnClickQDialogListener{
            fun onClick(dialog: SwitchEnvDialog)
        }

    }
}