package com.sensu.automall.fragment

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.support.v4.app.FragmentActivity
import android.support.v4.app.FragmentManager
import com.alibaba.fastjson.JSON
import com.sensu.automall.BaseFragment
import com.sensu.automall.URL
import com.sensu.automall.activity_mycenter.OrderDetailActivity2
import com.sensu.automall.activity_mycenter.OrderListActivity
import com.sensu.automall.activity_mycenter.WriteOrderNewActivity
import com.sensu.automall.activity_search.SearchOrderActivity
import com.sensu.automall.model.CheckMergeModel
import com.sensu.automall.model.CheckOrderModel
import com.sensu.automall.tuhupaysdk.QplTuhuPaySdkActivity
import com.sensu.automall.utils.GsonParseUtil
import com.sensu.automall.utils.LogUtils
import com.sensu.automall.utils.RequestParams
import com.sensu.automall.wxapi.WXPayEntryActivity
import org.json.JSONObject

/**
 * 此为支付逻辑封装 ，但是h5页面的支付逻辑稍有不同。所以不包括在内。
 * 如需修改支付相关，别忘了{@link FastEntryActivity.java}
 */

/**
 * @
 */
class PayFragment : BaseFragment() {

    private var orderType=OrderTypeListener.NORMAL

    lateinit var checkOrderModel:CheckOrderModel
    var tuhupay_limit=false
    var qpl =false
    var InquiryDetail_URL=""
    var OrderNos=""
    companion object {
        private val FRAGMENT_TAG = "PAY"
        var orderTypeListener:OrderTypeListener?=null
        lateinit var manager:FragmentManager
        var from =FROM.CUSTOM
        var customer =true
        @JvmStatic
        fun injectIfNeededIn(activity: FragmentActivity, orderType:Int, OrderNos:String, orderTypeListener: OrderTypeListener, from:FROM=FROM.CUSTOM, InquiryDetail_URL:String="") {
            this.orderTypeListener=orderTypeListener
            this.from=from
            if(from==FROM.H5){
                customer=false
            }
            manager= activity.supportFragmentManager
            if (manager.findFragmentByTag(FRAGMENT_TAG) == null) {
                var payFragment =PayFragment()
                var bundle =Bundle()
                bundle.putInt(OrderTypeListener.ORDERTYPE,orderType)
                bundle.putString("InquiryDetail_URL",InquiryDetail_URL)
                bundle.putString("OrderNos",OrderNos)
                payFragment.arguments=bundle
                manager.beginTransaction().add(payFragment, FRAGMENT_TAG).commit()
                manager.executePendingTransactions()
            }else{
                manager.beginTransaction().show(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        LogUtils.i("onCreate")
        var bundle =arguments;
        if(bundle?.containsKey(OrderTypeListener.ORDERTYPE)!!){
            orderType =bundle.get(OrderTypeListener.ORDERTYPE) as Int
        }
        if(bundle?.containsKey("InquiryDetail_URL")){
            InquiryDetail_URL=bundle?.getString("InquiryDetail_URL")
        }
        if(bundle?.containsKey("OrderNos")){
            OrderNos =bundle.getString("OrderNos")
        }
        checkCustomerOrder(OrderNos)
    }

    override fun onHiddenChanged(hidden: Boolean) {
        super.onHiddenChanged(hidden)
        LogUtils.i("hidden="+hidden)
        if(!hidden){
            checkCustomerOrder(OrderNos)
        }
    }


    fun config(){
        var params= RequestParams();
        request(params,"config",URL.HTTP_TuhuPay_Config,false)
    }
    fun getToken( orderNos:String){
        var params= RequestParams();
        params.put("order_no",orderNos);
        params.put("terminalType","Android");
        request(params,"AppToken",URL.HTTP_TuhuPay_AppToken,false)
    }

    fun checkCustomerOrder(orderNos:String){
        var rpParams = RequestParams();
        rpParams.put("option", "CheckOrderInfoAndCreateMergePay_ForInquiryOrder");
        rpParams.put("orderNos", orderNos);

        when(orderType){
            OrderTypeListener.NORMAL  ->
                GetMeOrderInfoByOrderNo(orderNos)
            OrderTypeListener.INQUIRY ->
                CheckOrderInfoAndCreateMergePay_ForInquiryOrder(orderNos)
        }
    }

    fun GetMeOrderInfoByOrderNo(orderNo: String) {
        LogUtils.i("GetMeOrderInfoByOrderNo")
        val params = RequestParams()
        params.put("OrderNo", orderNo)
        request(params,"GetMeOrderInfoByOrderNo",URL.HTTP_GetMeOrderInfoByOrderNo,false)
    }
    fun CheckOrderInfoAndCreateMergePay_ForInquiryOrder(orderNo: String){

        var rpParams = RequestParams();
        rpParams.put("option", "CheckOrderInfoAndCreateMergePay_ForInquiryOrder");
        rpParams.put("orderNos", orderNo);
        request(rpParams,"CheckCustomerOrder",URL.HTTP_CheckOrderInfoAndCreateMergePay_ForInquiryOrder,false)
    }

    override fun onSuccess(json: String?) {
        super.onSuccess(json)
        try {
            val jsonObject = JSONObject(json)
            var body =jsonObject.optJSONObject("body")
            var method =jsonObject.optString("method")
            if ("CheckCustomerOrder".equals(method)) {
                var obj = body.optJSONObject("Data")
                checkOrderModel= JSON.parseObject(obj.toString(), CheckOrderModel::class.java) as CheckOrderModel
                config()
            }else if("GetMeOrderInfoByOrderNo".equals(method)){
                var obj = body.optJSONObject("Data")
                var checkMergeModel= GsonParseUtil.parseObject(obj.toString(),CheckMergeModel::class.java)
                if(checkMergeModel!=null){
                    checkOrderModel = CheckOrderModel()
                    checkOrderModel.orderIds=checkMergeModel.orderIds
                    checkOrderModel.orderNos=checkMergeModel.gmpOrderNo
                    checkOrderModel.totalPrice =checkMergeModel.meOrderPrice
                    if(checkMergeModel.isHaveExOrder){
                        checkOrderModel.orderNos =checkMergeModel.gmpOrderNo
                        if(activity!=null){
                            when(activity){
                                is OrderListActivity ->OrderListActivity.setOrderMergeListener(object :OrderMergeListener{
                                    override fun onCancel() {
                                        manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
                                    }

                                    override fun onMerge() {
                                        config()
                                    }
                                })
                                is SearchOrderActivity ->SearchOrderActivity.setOrderMergeListener(object :OrderMergeListener{
                                    override fun onCancel() {
                                        manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
                                    }

                                    override fun onMerge() {
                                        config()
                                    }
                                })
                                is OrderDetailActivity2 ->OrderDetailActivity2.setOrderMergeListener(object :OrderMergeListener{
                                    override fun onCancel() {
                                        manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
                                    }

                                    override fun onMerge() {
                                        config()
                                    }
                                })
                                is WriteOrderNewActivity -> WriteOrderNewActivity.setOrderMergeListener(object :OrderMergeListener{
                                    override fun onMerge() {
                                        config()
                                    }
                                    override fun onCancel() {
                                        manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()

                                    }

                                })
                                else -> android.widget.Toast.makeText(context,"请给对应的activity设置监听",android.widget.Toast.LENGTH_SHORT).show()
                            }

                        }
                        orderTypeListener?.onMerge(checkMergeModel.meOrderPrice)
                    }else{
                        config()
                    }
                }
            }else if("config".equals(method)){
                var data=body.optJSONObject("Data");
                var payChannels= JSON.parseArray(data.optJSONArray("Android").toString(),String::class.java) as List<String>;
                if(payChannels!=null && payChannels.size>0){
                    if(payChannels.contains("tuhu")){  //使用途虎支付的渠道
                        getToken(checkOrderModel?.orderNos!!);
                    }
                    if(payChannels.contains("f")){ //是否有额度支付
                        tuhupay_limit=true;
                    }
                    if(payChannels.contains("qpl")){  //使用原来的支付渠道
                        qpl=true
                        var code =-1
                        if(from ==FROM.H5){
                            code=21
                        }
                        activity?.startActivityForResult(Intent(context,
                                WXPayEntryActivity::class.java)
                                .putExtra("checkOrderModel",checkOrderModel)
                                .putExtra("tuhupay_limit",tuhupay_limit)
                                .putExtra("qpl",qpl)
                                .putExtra("from",from?.value)
                                .putExtra("InquiryDetail_URL",InquiryDetail_URL)
                                .putExtra("customerOrder", customer),code)
                        orderTypeListener?.onSuccess()
                        manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
                    }
                }
            }else if ("AppToken".equals(method)) {
                var token = body.optString("Data");
                if(tuhupay_limit){
                    var code =-1
                    if(from ==FROM.H5){
                        code=21
                    }
                    var intent= Intent(context, WXPayEntryActivity::class.java)
                    intent.putExtra("tuhupay_limit",tuhupay_limit)
                    intent.putExtra("qpl",qpl)
                    intent.putExtra("token",token)
                    intent.putExtra("from",from?.value)
                    intent.putExtra("checkOrderModel",checkOrderModel);
                    intent.putExtra("customerOrder", customer)
                    intent.putExtra("InquiryDetail_URL",InquiryDetail_URL)
                    activity?.startActivityForResult(intent,code)
                }else{
                    var bundle=Bundle()
                    bundle.putString("orderIds",checkOrderModel?.getOrderIds())
                    bundle.putString("totalPrice",checkOrderModel?.getTotalPrice())
                    bundle.putString("from",from?.value)
                    bundle.putString("InquiryDetail_URL",InquiryDetail_URL)
                    QplTuhuPaySdkActivity.goPay(context as Activity,false,bundle,token)
                }
                orderTypeListener?.onSuccess()
                manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
            }

        }catch (e: Exception){
            e.printStackTrace()
            orderTypeListener?.onFail(e.message!!)
            manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()
        }
    }

    override fun onFail(json: String?) {
        super.onFail(json)
        try {

            var jsonObject=JSONObject(JSONObject(json).optString("body"));
            var msg = jsonObject.optString("ErrorMsg")
            orderTypeListener?.onFail(msg)
            manager.beginTransaction().remove(manager.findFragmentByTag(FRAGMENT_TAG)).commit()

        }catch (e:Exception ){
            e.printStackTrace();
        }
    }

}

interface OrderTypeListener{
    companion object {
        const val NORMAL =0
        const val INQUIRY=1
        const val ORDERTYPE ="ordertype"
    }

    fun onSuccess()

    fun onFail(errorMsg:String)

    fun onMerge(totalMoney:String){}

}

 enum class FROM{
     H5("h5"),
     CUSTOM("");
     var value:String
     constructor(value:String){
         this.value=value
     }
}

interface OrderMergeListener {
    fun onMerge()
    fun onCancel()
}

