package com.sensu.automall.recyclerview

import android.content.Context
import android.graphics.Canvas
import android.graphics.Paint
import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.sensu.automall.R
import com.sensu.automall.model.SearchSortItem
import com.sensu.automall.utils.MassageUtils

class SearchSortHeadDecoration :RecyclerView.ItemDecoration{

    var mTitleHeight=0
    val mSubCategorys :List<SearchSortItem>
    val mContext:Context
    var mParentTitle=""

    var mPaint: Paint
    val mDecorationHeight = MassageUtils.dip2px(20f)

    constructor(context:Context,list:List<SearchSortItem>){
        mContext =context
        mSubCategorys =list
        mTitleHeight =MassageUtils.dip2px(40f)

        mPaint = Paint(Paint.ANTI_ALIAS_FLAG)
        mPaint.color = context.resources.getColor(R.color.bg_content)
    }

    companion object {
        var mCurrentTag = "0"

    }


    override fun onDrawOver(c: Canvas?, parent: RecyclerView?, state: RecyclerView.State?) {
        super.onDrawOver(c, parent, state)
        var gridLayoutManager = parent?.layoutManager as GridLayoutManager
        var spanSizeLookup =gridLayoutManager.spanSizeLookup
        var pos =gridLayoutManager.findFirstVisibleItemPosition()
        if(pos<0) return
        var spanSize =spanSizeLookup.getSpanSize(pos)

        var tag = (mSubCategorys.get(pos)).tag
        var isTranslate =false
        var child =parent.findViewHolderForLayoutPosition(pos).itemView
        mParentTitle = mSubCategorys.get(pos).parentTitle
        if((mSubCategorys.size > pos+1 && tag !== mSubCategorys.get(pos+1).tag)
            || (mSubCategorys.size > pos+2 && tag !== mSubCategorys.get(pos+2).tag)
            ||(mSubCategorys.size > pos+3 && tag !== mSubCategorys.get(pos+3).tag)){
            if(spanSize ==1){
                if(child.height +child.top <mTitleHeight){
                    c?.save()
                    isTranslate =true
                    var height =child.height + child.top -mTitleHeight
                    c?.translate(0f,height.toFloat())
                }
            }
        }
        drawHeader(parent,mParentTitle,c)
        if(isTranslate){
            c?.restore()
        }
        if(!TextUtils.equals(tag, mCurrentTag)){
            mCurrentTag =tag
            var position = mCurrentTag.toInt()
            checkListener?.check(position,false)
            mParentTitle = mSubCategorys.get(pos).nextParentTitle
        }

    }


    private fun drawHeader(parent:RecyclerView,parentTile:String,canvas: Canvas?){

        val topTitleView = LayoutInflater.from(mContext).inflate(R.layout.item_searchsort_title,parent,false)
        val tv_title =topTitleView.findViewById<TextView>(R.id.tv_title)
        tv_title.text= parentTile

        var title_width_spec=0
        var title_height_spec=0
        var layoutParams =topTitleView.layoutParams
        if(layoutParams==null){
            layoutParams =RecyclerView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT,ViewGroup.LayoutParams.WRAP_CONTENT)
            topTitleView.layoutParams =layoutParams
        }
        when(layoutParams.width){
            ViewGroup.LayoutParams.MATCH_PARENT ->{
                title_width_spec = View.MeasureSpec.makeMeasureSpec((parent.width-parent.paddingLeft-parent.paddingRight),View.MeasureSpec.EXACTLY)
            }
            ViewGroup.LayoutParams.WRAP_CONTENT ->{
                title_width_spec = View.MeasureSpec.makeMeasureSpec((parent.width-parent.paddingLeft-parent.paddingRight),View.MeasureSpec.AT_MOST)
            }
            else ->{
                title_width_spec =View.MeasureSpec.makeMeasureSpec(layoutParams.width,View.MeasureSpec.EXACTLY)
            }
        }

        when(layoutParams.height){
            ViewGroup.LayoutParams.MATCH_PARENT ->{
                title_height_spec = View.MeasureSpec.makeMeasureSpec((parent.height-parent.paddingTop-parent.paddingBottom),View.MeasureSpec.EXACTLY)
            }
            ViewGroup.LayoutParams.WRAP_CONTENT ->{
                title_height_spec = View.MeasureSpec.makeMeasureSpec((parent.height-parent.paddingTop-parent.paddingBottom),View.MeasureSpec.AT_MOST)
            }
            else ->{
                title_height_spec =View.MeasureSpec.makeMeasureSpec(mTitleHeight,View.MeasureSpec.EXACTLY)
            }
        }
        topTitleView.measure(title_width_spec,title_height_spec)
        topTitleView.layout(parent.paddingLeft,parent.paddingTop,parent.paddingLeft+topTitleView.measuredWidth,parent.paddingTop+topTitleView.measuredHeight)
        topTitleView.draw(canvas)
    }


//    override fun onDraw(c: Canvas, parent: RecyclerView, state: RecyclerView.State?) {
//        super.onDraw(c, parent, state)
//        val left = parent.paddingLeft
//        var right = parent.width - parent.paddingRight
//
//        val childCount = parent.childCount
//        for (i in 0 until childCount-1){
//            val childView = parent.getChildAt(i)
//            var left = childView.left
//            var top =  childView.top
//            var right = childView.right
//            var bottom =top + mDecorationHeight
//
//            if(mSubCategorys[i].hasNavigation){
//                c.drawRect(left.toFloat(),top.toFloat(),right.toFloat(),bottom.toFloat(),mPaint)
//            }else{
//                continue
//            }
//        }
//    }

//    override fun getItemOffsets(outRect: Rect?, view: View?, parent: RecyclerView, state: RecyclerView.State?) {
//        super.getItemOffsets(outRect, view, parent, state)
//        val childCount = parent.childCount
//        for (i in 0 until childCount-1) {
//            if(mSubCategorys[i].hasNavigation){
//                outRect?.set(0,0,0,mDecorationHeight)
//            }else{
//                outRect?.set(0,0,0,0)
//            }
//        }
//    }

    interface CheckListener{
        fun check(position:Int,isScroll:Boolean)
    }

    private var checkListener:CheckListener?=null

    fun setCheckListener(listener: CheckListener?){
        checkListener=listener
    }

}