package com.sensu.automall.utils

import android.content.Context
import android.os.Handler
import android.os.Message

class CountDownTimerUtil {

    constructor(){
        mTimerHandler = TimerHandler()
    }
    var mTimerHandler :TimerHandler

    inner class TimerHandler : Handler(){
        override fun handleMessage(msg: Message?) {
            super.handleMessage(msg)
            start()
        }
    }

    fun start(){
        mTimerHandler.postDelayed({
            mTimerHandler.sendEmptyMessage(0)
            mCountDownListener?.countDown()
        },3000)
    }


    interface CountDownListener{
        fun countDown()
    }

    private var mCountDownListener:CountDownListener ? =null

    fun setCountDownListener(listener: CountDownListener){
        this.mCountDownListener = listener
    }

}