package com.sensu.automall.utils;

import com.google.gson.Gson
import com.google.gson.JsonArray
import com.google.gson.JsonParser
import com.google.gson.reflect.TypeToken
import java.lang.reflect.ParameterizedType
import java.lang.reflect.Type
import java.util.*

object GsonParseUtil {

    val gson =Gson()
    /**
     * json to object
     */
    @JvmStatic
    fun <T> parseObject(json:String,type:Class<T>) : T{
        var result:T = gson.fromJson(json,type)
        return result
    }

    /**
     * object to json
     */
    @JvmStatic
    fun <T> parseToJson(obj:T):String{
        var result = gson.toJson(obj)
        return result
    }

    /**
     * json to list
     */
    @JvmStatic
    fun <T>  parseArray(json:String,clz:Class<T>) :MutableList<T>{
        //var result :MutableList<T>  = gson.fromJson(json, object:TypeToken<List<T>>(){}.getType())
        var result : MutableList<T> = mutableListOf()
        var jsonArray:JsonArray =JsonParser().parse(json).asJsonArray
        jsonArray?.forEach {
            result.add(Gson().fromJson(it,clz))
        }

        return result
    }
}
