package com.sensu.automall.widgets.alphascaletransformer

import android.support.v4.view.ViewPager
import android.view.View

/**
 * Created by royal on 23/05/2018.
 */
class AlphaScaleInTransformer : BasePageTransformer() {

    companion object {
        private val DEFAULT_MIN_SCALE : Float = 0.8f
        private val DEFAULT_MIN_ALPHA : Float = 0.5f
    }
    private var minScale : Float = DEFAULT_MIN_SCALE
    private var minAlpha : Float = DEFAULT_MIN_ALPHA

//    constructor(minAlpha : Float, minScale : Float, pageTransformer : ViewPager.PageTransformer) {
//        this.minAlpha = minAlpha
//        this.minScale = minScale
//        this.pageTransformer = pageTransformer
//    }

    override fun pageTransformer(view: View, position: Float) {
        val pageWidth : Int = view.width
        val pageHeight : Int = view.height
        view.pivotX = (pageWidth/2).toFloat()
        view.pivotY = (pageHeight/2).toFloat()
        view.scaleX = 0.999f

        if (position < -1) { //[-Infinity, -1]
            view.scaleX = minScale
            view.scaleY = minScale
            view.pivotX = pageWidth.toFloat()
            view.alpha = minAlpha
        }else if (position <= 1){
            if (position < 0){ //[-1 , 1]
                val scaleFactor : Float = (1 + position) * (1 - minScale) + minScale
                val alphaFactor : Float = minAlpha + (1 - minAlpha) * (1 + position)
                view.scaleX = scaleFactor
                view.scaleY = scaleFactor
                view.pivotX = pageWidth * (DEFAULT_CENTER + (DEFAULT_CENTER * -position))
                view.alpha = alphaFactor
            }else { //[-1 , 0] [0 , -1]
                val scaleFactor : Float = (1 - position) * (1 - minScale) + minScale
                val alphaFactor : Float = minAlpha + (1 - minAlpha) * (1 - position)
                view.scaleX = scaleFactor
                view.scaleY = scaleFactor
                view.pivotX = pageWidth * ((1 - position) * DEFAULT_CENTER)
                view.alpha = alphaFactor
            }
        } else { //[1 , +Infinity]
            view.scaleX = minScale
            view.scaleY = minScale
            view.pivotX = 0.toFloat()
            view.alpha = minAlpha
        }

    }

}